unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Menus, ExtDlgs, Unit2;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Graf1: TMenuItem;
    Novy1: TMenuItem;
    Ulozit1: TMenuItem;
    Konec1: TMenuItem;
    Image1: TImage;
    SavePictureDialog1: TSavePictureDialog;
    procedure FormCreate(Sender: TObject);
    procedure Ulozit1Click(Sender: TObject);
    procedure Konec1Click(Sender: TObject);
    procedure Novy1Click(Sender: TObject);
  private
    procedure drawFunction(a,b:integer;dm,hm:real);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var color:TColor;
begin
 color := Image1.Canvas.Pen.Color;
 Image1.Canvas.Pen.Color := clWhite;
 Image1.Canvas.FillRect(Rect(0,0,Image1.Width,Image1.Height));
 Image1.Canvas.Pen.Color := color;
 Image1.Canvas.MoveTo(0, Image1.Height div 2);
 Image1.Canvas.LineTo(Image1.Width, Image1.Height div 2);
 Image1.Canvas.MoveTo(Image1.Width div 2, 0);
 Image1.Canvas.LineTo(Image1.Width div 2, Image1.Height);
end;

procedure TForm1.Ulozit1Click(Sender: TObject);
begin
 if SavePictureDialog1.Execute then
 begin
  Image1.Picture.SaveToFile(SavePictureDialog1.FileName);
 end;
end;

procedure TForm1.Konec1Click(Sender: TObject);
begin
 Application.Terminate;
end;

procedure TForm1.Novy1Click(Sender: TObject);
begin
 if form2.ShowModal = mrOK then
  drawFunction(form2.getA, form2.getB, form2.getDM, form2.getHM);
end;

procedure TForm1.drawFunction(a,b:integer;dm,hm:real);
var i,x,y,startx,endx:integer;
    len,value,stepx,koefy:real;
begin
 stepx:= 6*Pi/Image1.Width;
 koefy:= Image1.Height/6;
 len := hm - dm;
 startx:=trunc((dm - (-3*Pi))/stepx);
 endx:=trunc((hm - (-3*Pi))/stepx);
 value:= a*sin(b*dm);
 y:=round(Image1.Height div 2 - value * koefy);
 Image1.Canvas.MoveTo(startx,y);
 for i:=1 to (endx-startx-1) do
 begin
  value := a*sin(b*(dm+i*stepx));
  y:= round(Image1.Height div 2 - value * koefy);
  Image1.Canvas.LineTo(startx+i,y);
 end;
end;
end.
